# GNU Solfege - eartraining for GNOME
# Copyright (C) 2000, 2001, 2002  Tom Cato Amundsen
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

# gnome emu

import gtk
from uiconsts import *
import uiconsts
from src import gu

def _add_help(self, a, b):
    print "add_help not implemented"


class App(gtk.Window):
    def __init__(self, a, b):
        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
        self._cid = 4
        self.__vbox = gtk.VBox()
        self.add(self.__vbox)
        self.__menubox = gu.bHBox(self.__vbox, gtk.FALSE)
        self.__toolbarbox = gu.bHBox(self.__vbox, gtk.FALSE)
        self.__contentsbox = gu.bVBox(self.__vbox)
        self.__appbarbox = gu.bHBox(self.__vbox, gtk.FALSE)
        self.__dockitems = {}
    def show(self):
        self.__vbox.show()
        self.__menubox.show()
        self.__toolbarbox.show()
        self.__contentsbox.show()
        self.__appbarbox.show()
        gtk.Window.show(self)
    def flash(self, msg):
        self.__appbar.g_statusbar.push(self._cid, msg)
        gtk.timeout_add(2000, self._pop_message, self._cid)
        self._cid = self._cid + 1
    def _pop_message(self, cid):
        self.__appbar.g_statusbar.pop(cid)
    def set_statusbar(self, bar):
        self.__appbarbox.pack_start(bar)
        bar.show()
        self.__appbar = bar
    def set_contents(self, c):
        self.__contentsbox.pack_start(c)
    def set_menus(self, menu):
        hdlbox = gtk.HandleBox()
        hdlbox.show()
        self.__dockitems['Menubar'] = hdlbox

        self.__menubox.pack_start(hdlbox, gtk.TRUE, gtk.TRUE)
        hdlbox.add(menu)
        menu.show()
    def add_toolbar(self, toolbar, name, behavior, placement, band_num,
                    band_position, offset):
        hdlbox = gtk.HandleBox()
        hdlbox.show()
        self.__dockitems[name] = hdlbox
        self.__toolbarbox.pack_start(hdlbox)
        self.__toolbarbox.reorder_child(hdlbox, offset)
        hdlbox.add(toolbar)
        toolbar.show()
    def get_dock_item_by_name(self, name):
        return self.__dockitems[name]

class PropertyBox(gtk.Dialog):
    def __init__(self):
        gtk.Dialog.__init__(self)
        self.set_resizable(gtk.FALSE)
        self.vbox.set_border_width(uiconsts.PAD)
        self.vbox.set_spacing(uiconsts.PAD)
        self.g_notebook = gtk.Notebook()
        self.g_notebook.show()
        self.vbox.pack_start(self.g_notebook, gtk.FALSE)

        self.g_ok = gtk.Button(stock='gtk-ok')
        self.g_ok.connect('clicked', self._ok)
        self.g_ok.set_sensitive(gtk.FALSE)
        self.action_area.pack_start(self.g_ok)

        self.g_apply = gtk.Button(stock='gtk-apply')
        self.g_apply.connect('clicked', self._apply)
        self.g_apply.set_sensitive(gtk.FALSE)
        self.action_area.pack_start(self.g_apply)

        self.g_cancel = gtk.Button(stock='gtk-cancel')
        self.g_cancel.connect('clicked', lambda widget: self.destroy())
        self.action_area.pack_start(self.g_cancel)

        self.g_help = gtk.Button(stock='gtk-help')
        self.g_help.connect('clicked', self.on_help)
        self.action_area.pack_start(self.g_help)
    def connect(self, event, cb):
        if event in ('apply', 'help'):
                pass
        else:
                gtk.Dialog.connect(self, event, cb)
    def append_page(self, page, label):
        self.g_notebook.append_page(page, label)
    def set_modified(self, m):
        self.g_ok.set_sensitive(gtk.TRUE)
        self.g_apply.set_sensitive(gtk.TRUE)
    def _ok(self, widget):
        self._apply(widget)
        self.destroy()
    def _apply(self, widget):
        for x in range(len(self.g_notebook.get_children())):
            self.on_apply(self.g_notebook.get_children()[x], x)
        self.on_apply(self.g_notebook, -1)
        self.g_apply.set_sensitive(gtk.FALSE)

class GnomeAppBar(gtk.HBox):
    def __init__(self):
        gtk.HBox.__init__(self)
        self.g_statusbar = gtk.Statusbar()
        self.g_statusbar.show()
        self.pack_start(self.g_statusbar, gtk.TRUE, gtk.TRUE)
        self.g_progressbar = gtk.ProgressBar()
        self.g_progressbar.show()
        self.pack_start(self.g_progressbar)
    def set_progress(self, p):
        self.g_progressbar.set_percentage(p)
    def pop(self):
        self.g_statusbar.pop(1)
    def push(self, msg):
        self.g_statusbar.push(msg, 1)

class GnomeCanvas(gtk.Label):
    def __init__(self):
        gtk.Label.__init__(self, "Not on windows")
        self.show()
    def root(self): pass

def GnomeStock(name):
    return gtk.Pixmap(None, 'gnomeemu/xpm/%s.xpm' % name, None)

def GnomeStockButton(pixmapname):
    p = GnomeStock(pixmapname)
    p.show()
    b = gtk.Button()
    b.add(p)
    return b

def About(name, version, copyright, text, authors, documenters, translator_credist, pix):
    w = gtk.Dialog()
    w.vbox.set_border_width(uiconsts.PAD_SMALL)
    w.vbox.set_spacing(uiconsts.PAD_SMALL)

    frame = gtk.Frame()
    w.vbox.pack_start(frame)
    mbox = gtk.VBox()
    mbox.set_border_width(uiconsts.PAD_SMALL)
    mbox.set_spacing(uiconsts.PAD_SMALL)
    frame.add(mbox)
    
    label = gtk.Label(name + " " + version)
    label.set_name("AboutHeading")
    evbox = gtk.EventBox()
    evbox.set_name('AboutHeadingBox')
    vbox = gtk.HBox()
    evbox.add(vbox)
    vbox.set_border_width(uiconsts.PAD)
    vbox.pack_start(label)
    mbox.pack_start(evbox, gtk.FALSE)

    evbox = gtk.EventBox()
    evbox.set_name("AboutBodyBox")
    bodybox = gtk.VBox()
    bodybox.set_border_width(uiconsts.PAD)
    evbox.add(bodybox)
    mbox.pack_start(evbox)

    label = gtk.Label(copyright)
    label.set_name("Heading2")
    label.set_alignment(0.0, 0.0)
    bodybox.pack_start(label)

    ahbox = gtk.HBox()
    bodybox.pack_start(ahbox)
    
    label = gtk.Label(_("Authors:"))
    label.set_alignment(0.0, 0.0)
    label.set_name("Heading3")
    ahbox.pack_start(label, gtk.FALSE)

    avbox = gtk.VBox()
    ahbox.pack_start(avbox)

    for author in authors:
        label = gtk.Label(author)
        label.set_alignment(0.0, 0.0)
        avbox.pack_start(label)

    label = gtk.Label(text)
    label.set_alignment(0.0, 1.0)
    label.set_justify(gtk.JUSTIFY_LEFT)
    bodybox.pack_start(label)
    b = gtk.Button(_("Close"))
    b.connect('clicked', lambda btn, w=w: w.destroy())
    w.action_area.pack_start(b)
    w.show_all()
    return w

class _ErrorDialog(gtk.Dialog):
    def __init__(self, title, msg, parent=None):
        gtk.Dialog.__init__(self, title)
        self.vbox.set_spacing(uiconsts.PAD)
        self.set_transient_for(parent)
        hbox = gtk.HBox()
        hbox.set_border_width(uiconsts.PAD)
        self.vbox.pack_start(hbox)

        im = gtk.Image()
        im.set_from_stock('gtk-dialog-error', gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(im, gtk.FALSE, gtk.FALSE)

        label = gtk.Label(msg)
        hbox.pack_start(label)
        b = gtk.Button(stock='gtk-ok')
        self.action_area.pack_start(b)
        b.connect('clicked', self.close)
        self.set_modal(gtk.TRUE)
        self.show_all()
    def close(self, *v):
        self.destroy()

def gnome_error_dialog_parented(msg, parent):
    dlg = _ErrorDialog('error', msg, parent)
    dlg.show()
